matrix:
  platform:
    - debian13
    - macos_arm64
    - ubuntu2404
    - ubuntu2404_arm64
    - windows
  bazel: [7.x, 8.x, 9.x, rolling]
tasks:
  verify_targets:
    name: Verify build targets
    platform: ${{ platform }}
    bazel: ${{ bazel }}
    build_flags:
      - '--process_headers_in_dependencies'
    build_targets:
      - '@boost.thread//:boost.thread'

bcr_test_module:
  module_path: test
  matrix:
    platform:
      - macos_arm64
      - ubuntu2404
      - ubuntu2404_arm64
      - windows
    gcc14_platform:
      - debian13
    bazel: [7.x, 8.x, 9.x, rolling]
  tasks:
    run_test_module:
      name: Run test module
      platform: ${{ platform }}
      bazel: ${{ bazel }}
      build_flags:
        - '--process_headers_in_dependencies'
      build_targets:
        - //...
      test_targets:
        - //...
    run_gcc14_test_module:
      name: Run gcc14 test module
      platform: ${{ gcc14_platform }}
      bazel: ${{ bazel }}
      build_flags:
        - '--process_headers_in_dependencies'
      build_targets:
        - //...
      test_targets:
        - //...
        # These tests are failed on debian13(gcc14).
        # This issue may be related. https://github.com/boostorg/exception/issues/60 
        - -//:test_5351
        - -//:test_futures
